; Marathon/theme.jl

(defgroup Marathon-frame "Marathon Frame")

(defcustom Marathon:active-text "white"
  "Colour of active text."
  :group Marathon-frame
  :type color)

(defcustom Marathon:inactive-text "black"
  "Colour of inactive text."
  :group Marathon-frame
  :type color)  

(defcustom Marathon:active-title "title_active.png"
  "Bar for active title."
  :group Marathon-frame
  :type file-name)
  
(defcustom Marathon:inactive-title "title_inactive.png"
  "Bar for inactive title."
  :group Marathon-frame
  :type file-name)

(let*
  (
    (font-colors (list Marathon:inactive-text
                       Marathon:active-text))
    
    (close-image (list (make-image "close_button.png")
                        nil
                       (make-image "close_button_green.png")
                       (make-image "close_button_red.png")))
    (max-image (list (make-image "max_button.png")
                      nil
                     (make-image "max_button_green.png")
                     (make-image "max_button_red.png")))
    (min-image (list (make-image "min_button.png")
                      nil
                     (make-image "min_button_green.png")
                     (make-image "min_button_red.png")))
    (menu-image (list (make-image "menu_button.png")
                      nil
                     (make-image "menu_button_green.png")
                     (make-image "menu_button_red.png")))
    (title-image (list (make-image Marathon:inactive-title)
                       (make-image Marathon:active-title)))
    (top-left-image (make-image "top_left_button_area.png"))
    (top-left-shaped-image (make-image "top_left_button_area_shaped.png"))
    (top-right-image (make-image "top_right_button_area.png"))
    (top-right-shaped-image (make-image "top_right_button_area_shaped.png"))
    (top-right-transient-image (make-image "top_right_button_area_transient.png"))
    (bottom-left-image (make-image "bottom_left_corner.png"))
    (bottom-image (make-image "horizontal_border.png"))
    (bottom-right-image (make-image "bottom_right_corner.png"))
    (side-image (make-image "vertical_border.png"))

    (frame `(
        ((background . ,top-left-image)
         (top-edge . -19)
         (left-edge . -5)
         (class . title))
        ((background . ,title-image)
         (foreground . ,font-colors)
         (text . ,window-name)
         (x-justify . center)
         (y-justify . center)
         (left-edge . 14)
         (right-edge . 48)
         (top-edge . -19)
         (height . 19)
         (class . title))
        ((background . ,top-right-image)
         (right-edge . -5)
         (top-edge . -19)
         (class . title))
        ((background . ,side-image)
         (left-edge . -5)
         (top-edge . 0)
         (bottom-edge . 0)
         (class . left-border))
        ((background . ,side-image)
         (right-edge . -5)
         (top-edge . 0)
         (bottom-edge . 0)
         (class . right-border))
        ((background . ,bottom-left-image)
         (left-edge . -5)
         (bottom-edge . -5)
         (class . bottom-left-corner))
        ((background . ,bottom-image)
         (left-edge . 0)
         (right-edge .0)
         (bottom-edge . -5)
         (class . bottom-border))
        ((background . ,bottom-right-image)
         (right-edge . -5)
         (bottom-edge . -5)
         (class . bottom-right-corner))
        
        ((background . ,close-image)
         (right-edge . -3)
         (top-edge . -17)
         (class . close-button))
        ((background . ,max-image)
         (right-edge . 14)
         (top-edge . -17)
         (class . maximize-button))
        ((background . ,min-image)
         (right-edge . 31)
         (top-edge . -17)
         (class . iconify-button))
        ((background . ,menu-image)
         (left-edge . -3)
         (top-edge . -17)
         (class . menu-button))
      ))
      
    (shaped-frame `(
        ((background . ,top-left-shaped-image)
         (top-edge . -19)
         (left-edge . -5)
         (class . title))
        ((background . ,title-image)
         (foreground . ,font-colors)
         (text . ,window-name)
         (x-justify . center)
         (y-justify . center)
         (left-edge . 14)
         (right-edge . 48)
         (top-edge . -19)
         (height . 19)
         (class . title))
        ((background . ,top-right-shaped-image)
         (right-edge . -5)
         (top-edge . -19)
         (class . title))
        
        ((background . ,close-image)
         (right-edge . -3)
         (top-edge . -17)
         (class . close-button))
        ((background . ,max-image)
         (right-edge . 14)
         (top-edge . -17)
         (class . maximize-button))
        ((background . ,min-image)
         (right-edge . 31)
         (top-edge . -17)
         (class . iconify-button))
        ((background . ,menu-image)
         (left-edge . -3)
         (top-edge . -17)
         (class . menu-button))
      ))
      
    (transient-frame `(
        ((background . ,top-left-image)
         (top-edge . -19)
         (left-edge . -5)
         (class . title))
        ((background . ,title-image)
         (foreground . ,font-colors)
         (text . ,window-name)
         (x-justify . center)
         (y-justify . center)
         (left-edge . 14)
         (right-edge . 14)
         (top-edge . -19)
         (height . 19)
         (class . title))
        ((background . ,top-right-transient-image)
         (right-edge . -5)
         (top-edge . -19)
         (class . title))
        ((background . ,side-image)
         (left-edge . -5)
         (top-edge . 0)
         (bottom-edge . 0)
         (class . left-border))
        ((background . ,side-image)
         (right-edge . -5)
         (top-edge . 0)
         (bottom-edge . 0)
         (class . right-border))
        ((background . ,bottom-left-image)
         (left-edge . -5)
         (bottom-edge . -5)
         (class . bottom-left-corner))
        ((background . ,bottom-image)
         (left-edge . 0)
         (right-edge .0)
         (bottom-edge . -5)
         (class . bottom-border))
        ((background . ,bottom-right-image)
         (right-edge . -5)
         (bottom-edge . -5)
         (class . bottom-right-corner))
        
        ((background . ,close-image)
         (right-edge . -3)
         (top-edge . -17)
         (class . close-button))
        ((background . ,menu-image)
         (left-edge . -3)
         (top-edge . -17)
         (class . menu-button))
      ))
      
    (shaped-transient-frame `(
        ((background . ,top-left-shaped-image)
         (top-edge . -19)
         (left-edge . -5)
         (class . title))
        ((background . ,title-image)
         (foreground . ,font-colors)
         (text . ,window-name)
         (x-justify . center)
         (y-justify . center)
         (left-edge . 14)
         (right-edge . 14)
         (top-edge . -19)
         (height . 19)
         (class . title))
        ((background . ,top-left-shaped-image)
         (right-edge . -5)
         (top-edge . -19)
         (class . title))
        
        ((background . ,close-image)
         (right-edge . -3)
         (top-edge . -17)
         (class . close-button))
        ((background . ,menu-image)
         (left-edge . -3)
         (top-edge . -17)
         (class . menu-button))
      ))

   )
      
  (add-frame-style 'Marathon
    (lambda (w type)
      (cond 
            ((eq type 'transient) transient-frame)
            ((eq type 'shaped-transient) shaped-transient-frame)
            ((eq type 'shaped) shaped-frame)
            ((eq type 'unframed) nil-frame)
            (t frame))))            
)
